CON

   _clkmode = xtal1 + pll16x
   _xinfreq = 5_000_000

  RS = 25                         {lcd control}
  RW = 26                         {lcd control}
  E  = 27                         {lcd control}
  DBLow  = 0                      {lcd control}
  DBHigh = 3                      {lcd control}

  SHT_DATA      = 13                                    ' SHT-11 data pin
  SHT_CLOCK     = 15                                    ' SHT-11 clock pin

  CLS         = $0                                      ' clear screen
  CR          = $D                                      ' carriage return
  Deg         = $B0

OBJ
 
  LCD : "LCD_20x4"                                                         {LCD controler}
  debug : "FullDuplexSerial"  
  sht           : "Sensirion_full"
  fp            : "FloatString"
  f             : "Float32"
   SN    : "Simple_Numbers" 
  
VAR      
long stack1[128],idx,tc

byte  nstr[64]
      
long tempC1,tempC2,tempC3,rh1,rh2,rh3
PUB Main

    f.start

    LCD.Init( E, RS, RW, DBHigh, DBLow )                           
    LCD.usDelay( 5_000 )                                            
    LCD.Clear

    cognew(tempcontrol,@stack1)

     repeat
       print_temp 
       waitcnt(clkfreq + cnt)

  
PUB print_temp
     
    LCD.RawSetPos( $1C )                    
    LCD.PrintStr(tempC2)
    LCD.PrintStr( string(" C" ))

    LCD.RawSetPos( $5C )                   
    LCD.PrintStr( rh2 )
    LCD.PrintStr( string(" %" ))

    return
PUB tempcontrol

    sht.start(14,15)
    f.start
    
    repeat    
      tempC1 := celsius(f.FFloat(sht.readTemperature))     {floating point raw measurement temp}
      tempC2 := fp.FloatToFormat(tempC1, 2, 0)               { string for the display}
      tempC3 :=f.FTrunc(tempC1)                              { integer to calculate/use  }

      rh1 := humidity(tempC1, f.FFloat(sht.readHumidity))   {floating poitn ram measurement RH }
      rh2 := fp.FloatToFormat(rh1, 2, 0)                    { string for the display}
      rh3 :=f.FTrunc(rh1)
      waitcnt(clkfreq + cnt)

PUB celsius(t)
  ' from SHT1x/SHT7x datasheet using value for 3.5V supply
  ' celsius = -39.7 + (0.01 * t)
  return f.FAdd(-39.7, f.FMul(0.01, t))  


  
PUB humidity(t, rhh) | rhLinear
  ' rhLinear = -2.0468 + (0.0367 * rh) + (-1.5955E-6 * rh * rh)
  ' simplifies to: rhLinear = ((-1.5955E-6 * rh) + 0.0367) * rh -2.0468
  rhLinear := f.FAdd(f.FMul(f.FAdd(0.0367, f.FMul(-1.5955E-6, rhh)), rhh), -2.0468)
  ' rhTrue = (t - 25.0) * (0.01 + 0.00008 * rawRH) + rhLinear
  return f.FAdd(f.FMul(f.FSub(t, 25.0), f.FAdd(0.01, f.FMul(0.00008, rhh))), rhLinear)

PUB decx(value, digits) | div

'' Returns pointer to zero-padded, signed-decimal string
'' -- if value is negative, field width is digits+1

  clrstr(@nstr, 64)  
  digits := 1 #> digits <# 10

  if (value < 0)                                        ' negative value?   
    -value                                              '   yes, make positive
    nstr[idx++] := "-"                                  '   and print sign indicator

  div := 1_000_000_000                                  ' initialize divisor
  if digits < 10                                        ' less than 10 digits?
    repeat (10 - digits)                                '   yes, adjust divisor
      div /= 10
  
  value //= (div * 10)                                  ' truncate unused digits
  
  repeat digits
    nstr[idx++] := (value / div + "0")                  ' convert digit to ASCII
    value //= div                                       ' update value
    div /= 10                                           ' update divisor

  return @nstr
    
PRI clrstr(strAddr, size)

' Clears string at strAddr
' -- also resets global character pointer (idx)

  bytefill(strAddr, 0, size)                            ' clear string to zeros
  idx~                                                  ' reset index
  

          